SEPARATE (Singly_Linked_Lists)
PROCEDURE AddToEnd (L: IN OUT List; Word: IN WordType) IS
------------------------------------------------------------------
--|
--| iterative implementation of AddToEnd
--| we must do a linear search to find the end of the list
--|
--| Author: Michael B. Feldman, The George Washington University
--| Last Modified: September 1995
--|
------------------------------------------------------------------

  Current: List;  -- designates each node of input list in turn

BEGIN -- AddToEnd

  IF L = NULL THEN

    L := NEW ListNode'(Word,NULL);

  ELSE

    -- initialize the loop
    Current := L;

    -- search until the end
    WHILE Current.ALL.Next /= NULL LOOP
      Current := Current.ALL.Next;
    END LOOP;

    -- we found the end; Current designates last node
    -- so attach a new node to the node Current designates
    Current.ALL.Next := NEW ListNode'(Word, NULL);

  END IF;

END AddToEnd;
