WITH Swap_Generic;
WITH Ada.Text_IO;
WITH Ada.Integer_Text_IO;
PROCEDURE Test_Swap_Generic IS
------------------------------------------------------------------
--| Test program for Swap_Generic
--| Author: Michael B. Feldman, The George Washington University 
--| Last Modified: September 1995                                     
------------------------------------------------------------------

  X : Integer;
  Y : Integer;

  A : Character;
  B : Character;

  PROCEDURE IntegerSwap IS NEW Swap_Generic (ValueType => Integer);
  PROCEDURE CharSwap IS NEW Swap_Generic (ValueType => Character);

BEGIN -- Test_Swap_Generic

  X := 3;
  Y := -5;
  A := 'x';
  B := 'q';

  Ada.Text_IO.Put("Before swapping, X and Y are, respectively ");
  Ada.Integer_Text_IO.Put(Item => X, Width => 4);
  Ada.Integer_Text_IO.Put(Item => Y, Width => 4);
  Ada.Text_IO.New_Line;

  IntegerSwap(Value1 => X,Value2 => Y);

  Ada.Text_IO.Put("After  swapping, X and Y are, respectively ");
  Ada.Integer_Text_IO.Put(Item => X, Width => 4);
  Ada.Integer_Text_IO.Put(Item => Y, Width => 4);
  Ada.Text_IO.New_Line;
  Ada.Text_IO.New_Line;

  Ada.Text_IO.Put("Before swapping, A and B are, respectively ");
  Ada.Text_IO.Put(Item => A);
  Ada.Text_IO.Put(Item => B);
  Ada.Text_IO.New_Line;

  CharSwap(Value1 => A,Value2 => B);

  Ada.Text_IO.Put("After  swapping, A and B are, respectively ");
  Ada.Text_IO.Put(Item => A);
  Ada.Text_IO.Put(Item => B);
  Ada.Text_IO.New_Line;

END Test_Swap_Generic;
