WITH Text_IO;
WITH My_Flt_IO;
WITH MetricSystem; USE MetricSystem;
PROCEDURE TestMetric IS

  -- test some of the operations of the metric system package

  V   : Velocity;
  T   : Time;
  D   : Length;
  A   : Area;
  Vol : Volume;

BEGIN -- TestMetric

  -- these operations should all work correctly

  V := 23.0 * M_per_Sec;
  T := 3600.0 * Sec;

  D := V * T;

  Text_IO.Put("Distance = Rate * Time works as advertised");
  Text_IO.New_Line;
  Text_IO.Put("Distance is ");
  My_Flt_IO.Put(Item => Value(D), Fore => 1, Aft => 2, Exp => 0);
  Text_IO.Put(" meters.");
  Text_IO.New_Line;
  Text_IO.New_Line;

  D := 3.0 * Meter;
  A := D * D;

  Text_IO.Put("Area = Distance * Distance works as advertised");
  Text_IO.New_Line;
  Text_IO.Put("Area is ");
  My_Flt_IO.Put(Item => Value(A), Fore => 1, Aft => 2, Exp => 0);
  Text_IO.Put(" square meters.");
  Text_IO.New_Line;
  Text_IO.New_Line;

  Vol := A * D;

  Text_IO.Put("Volume = Area * Distance works as advertised");
  Text_IO.New_Line;
  Text_IO.Put("Volume is ");
  My_Flt_IO.Put(Item => Value(Vol), Fore => 1, Aft => 2, Exp => 0);
  Text_IO.Put(" cubic meters.");
  Text_IO.New_Line;
  Text_IO.New_Line;

  D := D + D;

  Text_IO.Put("Distance = Distance + Distance works as advertised");
  Text_IO.New_Line;
  Text_IO.Put("Distance is ");
  My_Flt_IO.Put(Item => Value(D), Fore => 1, Aft => 2, Exp => 0);
  Text_IO.Put(" meters.");
  Text_IO.New_Line;
  Text_IO.New_Line;

  BEGIN -- block for exception handler
    D := D * D;
    Text_IO.Put("Distance = Distance * Distance worked, but should not");
    Text_IO.New_Line;
  EXCEPTION
    WHEN Constraint_Error =>
      Text_IO.Put("Constraint Error Raised on Distance = Distance * Distance");
      Text_IO.New_Line;
    WHEN Dimension_Error =>
      Text_IO.Put("Dimension Error Raised on Distance = Distance * Distance");
      Text_IO.New_Line;
  END; -- exception block

  BEGIN -- block for exception handler
    D := T + D;
    Text_IO.Put("Distance = Time + Distance worked, but should not");
    Text_IO.New_Line;
  EXCEPTION
    WHEN Constraint_Error =>
      Text_IO.Put("Constraint Error Raised on Distance = Time + Distance");
      Text_IO.New_Line;
    WHEN Dimension_Error =>
      Text_IO.Put("Dimension Error Raised on Distance = Time + Distance");
      Text_IO.New_Line;
  END; -- exception block

END TestMetric;
