  PROCEDURE EnterMove (Player : GameSymbol;
                       TicTacToe : IN OUT BoardArray) IS
  
  -- Stores an X or O (identity of Player) in the array TicTacToe.
  -- Pre : Player is "X" or "O" and array TicTacToe has at least
  --       one empty cell.
  -- Post: The value of Player is stored in the empty cell of      
  --       TicTacToe whose coordinates are read in; the rest
  --       of array TicTacToe is unchanged.
  -- Uses: RobustInput.Get, Text_IO.Put, Text_IO.New_Line;
    
    MoveRow    : Positive;    -- coordinates of selected cell   
    MoveColumn : Positive;

  BEGIN  -- EnterMove   

    LOOP
      Text_IO.Put(Item => "Enter your move row and then the column");
      Text_IO.New_Line;
      RobustInput.Get (MinVal => 1, MaxVal => 3, Item => MoveRow);
      RobustInput.Get (MinVal => 1, MaxVal => 3, Item => MoveColumn);
      
      IF TicTacToe(MoveRow, MoveColumn) = Empty THEN
        EXIT;
      ELSE
        Text_IO.Put(Item => "Cell is occupied - try again");  
        Text_IO.New_Line;
      END IF;
    END LOOP;
    -- assertion: A valid move is entered   

    TicTacToe(MoveRow, MoveColumn) := Player;  -- Define cell   

  END EnterMove;
