-- procedure specification for GenericSwapSort
GENERIC -- procedure specification for GenericSwapSort
  
  -- here are all the generic formal parameters
  TYPE ElementType IS PRIVATE;  -- any nonlimited type will do
  TYPE IndexType   IS (<>);     -- any discrete type for index
  TYPE ListType    IS ARRAY (IndexType RANGE <>) OF ElementType;
  WITH FUNCTION Compare (Left, Right : ElementType) RETURN Boolean;

PROCEDURE GenericSwapSort(List: IN OUT ListType);


-- procedure body for GenericSwapSort
WITH GenericSwap;               -- context clause
PROCEDURE GenericSwapSort(List: IN OUT ListType) IS

  -- we need to make an instance of GenericSwap for this case
  PROCEDURE Exchange IS NEW GenericSwap (ValueType => ElementType);

BEGIN -- GenericSwapSort

  FOR PositionToFill IN List'First..List'Last LOOP

    -- Store in List(PositionToFill) the "largest" element remaining
    -- in the subarray List(PositionToFill..List'Last)

    FOR ItemToCompare IN PositionToFill..List'Last LOOP
      IF Compare(List(ItemToCompare),  List(PositionToFill)) THEN
        Exchange(List(PositionToFill), List(ItemToCompare));
      END IF;
    END LOOP;
    -- assert: element at List(PositionToFill) is "largest" in subarray

  END LOOP;

END GenericSwapSort;
