-- specification for GenericMaximum
GENERIC
  TYPE ValueType IS PRIVATE;
  WITH FUNCTION Compare(L, R : ValueType) RETURN Boolean;
FUNCTION GenericMaximum(L, R : ValueType) RETURN ValueType;

-- body of Generic Maximum
FUNCTION GenericMaximum(L, R : ValueType) RETURN ValueType IS

 -- generic version of maximum finder.
 -- Pre: L and R are defined
 -- Post: returns the "larger" of L and R, that is, L if the comparison
 --   is true and R otherwise.

BEGIN -- GenericMaximum

  IF Compare(L, R) THEN
    RETURN L;
  ELSE
    RETURN R;
  END IF;

END GenericMaximum;
