WITH Text_IO;
WITH My_Int_IO;
PROCEDURE TestTower IS

  SUBTYPE Pegs IS Character RANGE 'A'..'C';

  PROCEDURE Tower (FromPeg : Pegs;
                   ToPeg   : Pegs;
                   AuxPeg  : Pegs;
                   N       : Natural) IS

  -- Moves N disks from FromPeg to ToPeg
  -- using AuxPeg as an auxiliary.   

  BEGIN  -- Tower  

    IF N = 1 THEN
      -- stopping case
      Text_IO.Put(Item => "Move disk 1 from peg ");
      Text_IO.Put(Item => FromPeg);
      Text_IO.Put(Item => " to peg ");
      Text_IO.Put(Item => ToPeg);
      Text_IO.New_Line;
    ELSE
      -- recursive step   
      Tower (FromPeg, AuxPeg, ToPeg, N-1);

      Text_IO.Put(Item => "Move disk ");
      My_Int_IO.Put(Item => N, Width => 1);
      Text_IO.Put(Item => " from peg ");
      Text_IO.Put(Item => FromPeg);
      Text_IO.Put(Item => " to peg ");
      Text_IO.Put(Item => ToPeg);
      Text_IO.New_Line;

      Tower (AuxPeg, ToPeg, FromPeg, N-1);
    END IF;

  END Tower;

BEGIN -- TestTower

  Tower(FromPeg => 'A', ToPeg => 'B', AuxPeg => 'C', N => 5);

END TestTower;
