FUNCTION BinarySearch (Table: SearchArray; Target: KeyType) RETURN Natural IS

-- Performs an iterative binary search of an ordered array of 
-- keys with bounds Table'First..Slice'Last.
-- Pre : Target and Table are defined.
--     0 < Table'First <= Slice'Last
-- Post: Returns the subscript of Target if found in array Table;
--     otherwise, returns 0

  Middle : Natural;      -- the subscript of the middle element   
  Found :  Boolean;      -- program flag
  Left :   Natural;  
  Right :  Natural; 

BEGIN -- BinarySearch   

  Left := Table'First;
  Right := Table'Last;
  Found := False;

  WHILE (Left <= Right) AND (NOT Found) LOOP
    -- invariant:
    --    last subarry searched was not null and
    --    Target /= Table(Middle) for all prior values of Middle

    Middle := (Left + Right) / 2;    -- define Middle   
    IF Target = Table(Middle) THEN
      Found := True;
    ELSIF Target < Table(Middle) THEN
      Right := Middle - 1;                -- search lower subarray   
    ELSIF Target > Table(Middle) THEN
      Left := Middle + 1;                 -- search upper subarray   
    END IF;

  END LOOP;

  -- Assertion:  Target is found or search subarry is null.    
  IF Found THEN
    RETURN Middle;                      -- Target is found   
  ELSE
    RETURN 0;                           -- Target not found   
  END IF;

END BinarySearch;
