WITH Text_IO;
WITH My_Int_IO;
PROCEDURE TestPrintBack IS

  TYPE IntArray IS ARRAY(Integer RANGE <>) OF Integer;
  Test: IntArray(1..10);

  PROCEDURE PrintBackward (X : IntArray) IS
    
    -- Prints a slice of an integer array X with bounds X'First..X'Last.
    -- Pre : Array X is defined and X'First <= X'Last. 
    -- Post: Displays X(X'Last), X(X'Last-1), ... , X(X'First)
    
  BEGIN -- PrintBackward 

    IF X'First = X'Last THEN -- stopping case - slice has only one element
      My_Int_IO.Put(Item => X(X'Last), Width => 3); 
    ELSIF X'First > X'Last THEN    -- error in specifying slice bounds
      Text_IO.Put(Item => "Error in bounds of array slice");  
      Text_IO.New_Line;
    ELSE
      -- recursive step   
      My_Int_IO.Put(Item => X(X'Last), Width => 3);
      PrintBackward (X => X(X'First..X'Last-1));
    END IF;

  END PrintBackward;

BEGIN

  Test := (1,3,5,7,9,11,13,15,17,19);
  PrintBackward(X => Test(1..3));
  Text_IO.New_Line;

END TestPrintBack;
