WITH Text_IO;
WITH My_Int_IO;
PROCEDURE TestPrintNorm IS

  TYPE IntArray IS ARRAY(Integer RANGE <>) OF Integer;
  Test: IntArray(1..10);

  PROCEDURE PrintNormal (X : IntArray) IS
    
    -- Displays a slice of an integer array X with bounds X'First..X'Last.
    -- Pre : Array X is defined and X'First <= X'Last. 
    -- Post: Displays X(X'First), X(X'First+1), ... , X(X'Last)
    
  BEGIN -- PrintNormal 

    IF X'First = X'Last THEN -- stopping case - slice has only one element
      My_Int_IO.Put(Item => X(X'Last), Width => 3); 
    ELSIF X'First > X'Last THEN    -- error in specifying slice bounds
      Text_IO.Put(Item => "Error in bounds of array slice");  
      Text_IO.New_Line;
    ELSE
      -- recursive step   
      PrintNormal (X => X(X'First..X'Last-1));
      My_Int_IO.Put(Item => X(X'Last), Width => 3);
    END IF;

  END PrintNormal;

BEGIN

  Test := (1,3,5,7,9,11,13,15,17,19);
  PrintNormal(X => Test(4..6));
  Text_IO.New_Line;

END TestPrintNorm;
