SEPARATE (GenericTables)
PROCEDURE Traverse (Table : TableType) IS

--  Repeatedly calls procedure Visit (a generic parameter) to
--  process each element of an ordered list.
--  Pre : List points to the header node of an ordered list.
--  Post: Each element is operated on in turn by procedure Visit.

  Next : NodePointer;     -- pointer to each list node
  NextKey : KeyType;      -- key of node Next.ALL

BEGIN -- Traverse

  IF Table.Head = NULL THEN
    RAISE UninitializedTable;
  END IF;

  Next := Table.Head.Link;   -- start with first node after dummy
  ExtractKey (Next.Item, NextKey);                -- get node key
  WHILE Bigger(MaxKey, NextKey) LOOP
  -- invariant:
  --   Maxkey > key of each prior node pointed to by Next
    Visit (Next.Item);                       -- visit node
    Next := Next.Link;                       -- advance Next
    ExtractKey (Next.Item, NextKey);
  END LOOP;

END Traverse;

