WITH VStrings; USE VStrings;
PACKAGE Passengers IS

-- specification for package defining the type Passenger

  MaxSeats : CONSTANT Positive := 30;
  MinKey   : CONSTANT VString := MakeVString("AAAAAAA");
  MaxKey   : CONSTANT VString := MakeVString("zzzzzzz");

-- Data Structure   

  TYPE ClassType IS 
    (FirstClass, Business, Economy, StandBy, Undesignated);
  SUBTYPE NameType IS VString;
  SUBTYPE SeatRange IS Positive RANGE 1..MaxSeats;
  TYPE Passenger IS RECORD
    Name     : NameType;
    Class    : ClassType;
    NumSeats : SeatRange;
  END RECORD;

-- Operators   

  PROCEDURE ReadPass (OnePass : OUT Passenger);
  -- Reads one record of type Passenger.

  PROCEDURE WritePass (OnePass : Passenger);
  -- Displays one record of type Passenger.

  PROCEDURE StoreName (OnePass : IN OUT Passenger;
		       Name : NameType);
  -- Inserts the key value in record OnePass.   

  PROCEDURE RetrieveName (OnePass : Passenger;
			  Name : OUT NameType);
  -- Extracts the key of record OnePass.   

END Passengers;

