WITH Text_IO;
WITH My_Int_IO;
WITH Passengers;
WITH GenericTables;
WITH VStrings;
PROCEDURE BuildFlightList IS

-- Builds a flight list using abstract data type GenericTables

  PACKAGE FlightLists IS NEW GenericTables(
    Element    => Passengers.Passenger,
    KeyType    => Passengers.NameType,
    MinKey     => Passengers.MinKey,
    MaxKey     => Passengers.MaxKey,
    InsertKey  => Passengers.StoreName,
    ExtractKey => Passengers.RetrieveName,
    Bigger     => VStrings.">",
    Visit      => Passengers.WritePass);

  MaxPass : CONSTANT Positive := 4;      -- maximum table size

  Flight23 : FlightLists.TableType;  -- table of passengers
  OnePass  : Passengers.Passenger;       -- a passenger
  Success  : Boolean;                    -- program flag

BEGIN -- BuildFlightList

  -- Initialize the list   
   FlightLists.CreateTable (Table => Flight23);

  -- Read and insert up to four passengers in Flight23
  FOR Count IN 1..MaxPass LOOP

    Text_IO.Put(Item => "Enter data for next passenger.");
    Text_IO.New_Line;
    Passengers.ReadPass (OnePass => OnePass);
    FlightLists.Insert (Table => Flight23,
			    El => OnePass, Success => Success);

    IF Success THEN
      Text_IO.Put(Item => "Passenger inserted.");
    ELSE
      Text_IO.Put(Item => "Already booked - no insertion.");
    END IF;
    Text_IO.New_Line;  
    Text_IO.New_Line;

  END LOOP;

  -- Delete Smith   
  FlightLists.Delete (Table => Flight23,
		      Target => VStrings.MakeVString("Smith"),
		      Success => Success);
  IF Success THEN
    Text_IO.Put(Item => "Smith deleted.");  
    Text_IO.New_Line;  
    Text_IO.New_Line;
  END IF;

  -- Display the passenger list.   
  Text_IO.Put(Item => "The ordered passenger list follows.");  
  Text_IO.New_Line;
  FlightLists.Traverse (Table => Flight23);
  Text_IO.Put(Item => "The number of passengers in the list is ");
  My_Int_IO.Put(Item => 
		FlightLists.SizeOfTable(Flight23), Width => 2);
  Text_IO.New_Line;

END BuildFlightList;

