SEPARATE (GenericTables)
PROCEDURE Search (Table   : TableType;
		  Target  : KeyType;
		  Success : OUT Boolean) IS

--  Searches a search tree for Target.
--  Pre : Target is defined.
--  Post: Success is True if Target is found; otherwise,
--        Success is False.
       
  PROCEDURE Search (Parent  : Branch;
		    Target  : KeyType;
		    Success : OUT Boolean) IS

  --  Searches the subtree pointed to by Parent
  --  Pre : Target is defined.
  --  Post: Success is True if Target is found; otherwise,
  --        Success is False.

    NextKey : KeyType;       -- key of node Parent.ALL

  BEGIN -- Search
    IF Parent = NULL THEN
      Success := FALSE;           -- tree is empty
    ELSE
      ExtractKey (Parent.Item, NextKey);
      IF Bigger(Target, NextKey) THEN
	Search (Parent.Right, Target, Success);
      ELSIF Bigger(NextKey, Target) THEN
	Search (Parent.Left, Target, Success);
      ELSE -- Target = NextKey
	Success := TRUE;
      END IF;
    END IF;
  END Search;

BEGIN -- OuterSearch
  Search (Table.Root, Target, Success);
END Search;

