SEPARATE (GenericTables)
PROCEDURE Insert (Table   : IN OUT TableType;
		  El      : Element;
		  Success : OUT Boolean) IS

--  Inserts item El into a search tree.
--  Pre : El is defined.
--  Post: Success is True if insertion is performed; Success is False
--        if insertion is not performed because there is already
--        an element with the same key as El.

  ElKey    : KeyType;           -- key of record El
  TempFlag : Boolean;           -- because Success is OUT

  PROCEDURE Insert (Parent : IN OUT Branch;
		    El     : Element;
		    ElKey  : KeyType;
		    Success: OUT Boolean) IS

  -- Inserts item El in the subtree with root Parent.

    NextKey : KeyType;        -- key of Parent.ALL

  BEGIN -- Insert
    -- Check for empty tree.
    IF Parent = NULL THEN
      -- Attach new node containing El to Parent
      Parent := NEW TreeNode;
      Parent.Item := El;
      Success := True;
    ELSE -- search for correct insertion point
      ExtractKey (Parent.Item, NextKey);
      IF Bigger(ElKey, NextKey) THEN
	Insert (Parent.Right, El, ElKey, Success);
      ELSIF Bigger(NextKey, ElKey) THEN
	Insert (Parent.Left, El, ElKey, Success);
      ELSE -- ElKey is in tree
	Success := False;
      END IF;
    END IF;
  END Insert;

BEGIN -- Outer Insert

  ExtractKey (El, ElKey);                   -- get key
  Insert (Table.Root, El, ElKey, TempFlag);
  Success := TempFlag;
  IF TempFlag THEN
    Table.NumItems := Table.NumItems + 1;     -- new node in tree
  END IF;

END Insert;

