SEPARATE(GenericTables)
PROCEDURE Search (Table   : TableType;
		  Target  : KeyType;
		  Success : OUT Boolean) IS

--  Searches an ordered List for Target.
--  Pre : Table is an ordered list
--  Post: Success is True if Target is found; otherwise,
--        Success is False.

  Previous : NodePointer;  -- pointer to previous node
  Next     : NodePointer;  -- pointer to current node

BEGIN -- Search

  IF Table.Head = NULL THEN
    RAISE UninitializedTable;
  END IF;

  -- Start search at first dummy node.
  Previous := Table.Head;
  -- Perform search and define Success
  Locate (Target, Previous, Next, Success);

END Search;

