WITH Text_IO;
WITH My_Flt_IO;
PROCEDURE Pizzeria IS
 
  -- Computes and displays the unit price of a pizza
 
  SUBTYPE NonNegFloat IS Float RANGE 0.0 .. Float'Last;
  Pi : CONSTANT NonNegFloat := 3.14159;
 
  Diameter  : NonNegFloat;  -- input  - diameter of a pizza
  Price     : NonNegFloat;  -- input  - price of a pizza
  UnitPrice : NonNegFloat;  -- output - unit price of a pizza
  Area      : NonNegFloat;  -- output - area of a pizza 
  Radius    : NonNegFloat;  -- radius of a pizza
 
BEGIN -- Pizzeria
 
  -- Read in the pizza diameter and price
  Text_IO.Put (Item => "Size of pizza in inches > ");
  My_Flt_IO.Get (Item => Diameter);
  Text_IO.Put (Item => "Price of pizza $");
  My_Flt_IO.Get (Item => Price);  
 
  -- Compute the pizza area   
  Radius := Diameter/2.0;
  Area := Pi * Radius ** 2;
 
  -- Compute the pizza unit price
  UnitPrice := Price / Area;
 
  -- Display the unit price and area
  Text_IO.New_Line;
  Text_IO.Put (Item => "The pizza unit price is $");
  My_Flt_IO.Put (Item => UnitPrice, Fore => 1, Aft => 2, Exp => 0);
  Text_IO.New_Line;
  Text_IO.Put (Item => "The pizza area is ");
  My_Flt_IO.Put (Item => Area, Fore => 1, Aft => 2, Exp => 0);
  Text_IO.Put (Item => " square inches.");
  Text_IO.New_Line;
 
END Pizzeria;
