WITH Text_IO;
WITH My_Int_IO;
WITH Calendar; 
PROCEDURE TodayDate2 IS
 
-- Finds today's date and displays it 
--   in the form MONTH dd, yyyy
-- An enumeration type is used for months
-- The date is gotten from PACKAGE Calendar
 
  TYPE Months IS 
     (January, February, March, April, May, June, 
      July, August, September, October, November, December);

  PACKAGE Months_IO IS NEW Text_IO.Enumeration_IO(Enum => Months);
 
  Right_Now  : Calendar.Time;           -- holds internal clock value
  This_Year  : Calendar.Year_Number;    -- holds current year
  This_Month : Calendar.Month_Number;   -- holds current month 
  This_Day   : Calendar.Day_Number;     -- holds current day

  Month_Name: Months;
   
BEGIN -- TodayDate2
 
  -- Get the current time value from the computer's clock
  Right_Now := Calendar.Clock;
 
  -- Extract the current month, day, and year from the time value 
  This_Month := Calendar.Month(Date => Right_Now);
  This_Day   := Calendar.Day  (Date => Right_Now);
  This_Year  := Calendar.Year (Date => Right_Now);
 
  -- Format and display the date
  Month_Name := Months'Val(This_Month - 1); 
 
  Text_IO.Put (Item => "Today's date is ");
  Months_IO.Put (Item => Month_Name, Set => Text_IO.Upper_Case);
  Text_IO.Put (Item => ' ');
  My_Int_IO.Put (Item => This_Day, Width => 1);
  Text_IO.Put (Item => ',');
  My_Int_IO.Put (Item => This_Year, Width => 5);         
  Text_IO.New_Line;
 
END TodayDate2;
