WITH Text_IO;
WITH My_Flt_IO;
PROCEDURE ModPay IS

-- Computes and displays gross pay and net pay given an hourly
-- rate and number of hours worked.  Deducts a tax of $25 if
-- gross salary exceeds $100; otherwise, deducts no tax.

  SUBTYPE NonNegFloat IS Float RANGE 0.0 .. Float'Last;
  
  TaxBracket : CONSTANT NonNegFloat := 100.00;
                             -- maximum salary for no deduction
  Tax :        CONSTANT NonNegFloat := 25.00;   -- tax amount
 
  Hours : NonNegFloat; -- inputs - hours worked, hourly rate  
  Rate:   NonNegFloat; 
  Gross:  NonNegFloat; -- outputs - gross pay, net pay        
  Net:    NonNegFloat; 
 
BEGIN -- ModPay   

  -- Enter Hours and Rate   
  Text_IO.Put (Item => "Hours worked > ");
  My_Flt_IO.Get (Item => Hours);  
  Text_IO.Put (Item => "Hourly rate $");
  My_Flt_IO.Get (Item => Rate);  
  Text_IO.New_Line;
 
  -- Compute gross salary   
  Gross := Hours * Rate;
 
  -- Compute net salary   
  IF Gross > TaxBracket THEN
    Net := Gross - Tax;     -- Deduct a tax amount  
  ELSE
    Net := Gross;           -- Deduct no tax  
  END IF;
 
  -- Print Gross and Net   
  Text_IO.Put (Item => "Gross salary is $");
  My_Flt_IO.Put (Item => Gross, Fore => 1, Aft => 2, Exp => 0);
  Text_IO.New_Line;
  Text_IO.Put (Item => "Net salary is $");
  My_Flt_IO.Put (Item => Net, Fore => 1, Aft => 2, Exp => 0);
  Text_IO.New_Line;

END ModPay;
