WITH Text_IO;
WITH My_Int_IO;
WITH My_Flt_IO;
PROCEDURE CompDividend IS
 
  SUBTYPE NonNegFloat IS Float RANGE 0.0 .. Float'Last;

-- Finds and displays the insurance dividend.   
 
  BasicRate : CONSTANT NonNegFloat := 0.045; -- basic dividend rate 4.5%
  BonusRate : CONSTANT NonNegFloat := 0.005; -- bonus dividend rate 0.5%
 
  Premium   : NonNegFloat;   -- input  - premium amount
  NumClaims : Natural;       -- input  - number of claims
  Dividend  : NonNegFloat;   -- output - dividend amount   
 
BEGIN -- CompDividend   

  -- Enter Premium and NumClaims   
  Text_IO.Put (Item => "Premium amount > $");
  My_Flt_IO.Get (Item => Premium);  
  Text_IO.Put (Item => "Number of claims > ");
  My_Int_IO.Get (Item => NumClaims);  
  Text_IO.New_Line;
 
  -- Compute divided using bonus rate when earned
  IF NumClaims /= 0 THEN
    Dividend := Premium * BasicRate;
  ELSE
    Dividend := (Premium * BasicRate) + (Premium * BonusRate); 
  END IF;
 
  -- Display total dividend   
  Text_IO.Put (Item => "Total dividend is $");
  My_Flt_IO.Put (Item => Dividend, Fore => 1, Aft => 2, Exp => 0);
  Text_IO.New_Line;

  IF NumClaims = 0 THEN
    Text_IO.Put(Item => "This includes a bonus dividend for zero claims!");
    Text_IO.New_Line;
  END IF;

END CompDividend;
