WITH Text_IO;
PROCEDURE ThreeDays IS
 
  TYPE Days IS (Mon, Tue, Wed, Thu, Fri, Sat, Sun);
  PACKAGE Day_IO IS 
     NEW Text_IO.Enumeration_IO (Enum => Days);
 
  Yesterday : Days;
  Today     : Days;
  Tomorrow  : Days;
     
BEGIN

  -- prompt user to enter a day abbreviation
  Text_IO.Put (Item => "Enter the first 3 letters of a day of the week > ");
  Day_IO.Get (Item => Today);
   
  -- find yesterday
  IF Today = Days'First THEN
    Yesterday := Days'Last;
  ELSE
    Yesterday := Days'Pred(Today);
  END IF;
 
  Text_IO.Put (Item => "Yesterday was ");
  Day_IO.Put (Item => Yesterday);
  Text_IO.New_Line;
   
  Text_IO.Put (Item => "Today is ");
  Day_IO.Put (Item => Today);
  Text_IO.New_Line;
   
  -- find tomorrow
  IF Today = Days'Last THEN
    Tomorrow := Days'First;
  ELSE
    Tomorrow := Days'Succ(Today);
  END IF;
   
  Text_IO.Put (Item => "Tomorrow is ");
  Day_IO.Put (Item => Tomorrow); 
  Text_IO.New_Line; 

END ThreeDays;
 
