WITH Text_IO;
PROCEDURE WorkDays IS

  TYPE Days IS (Mon, Tue, Wed, Thu, Fri, Sat, Sun);
  SUBTYPE WeekDays IS Days RANGE Mon .. Fri;
  SUBTYPE WeekEnd  IS Days RANGE Sat .. Sun;
  PACKAGE Day_IO IS
     NEW Text_IO.Enumeration_IO (Enum => Days);

  Today     : Days;
  Tomorrow  : Days;

BEGIN

  -- prompt user to enter a day abbreviation
  Text_IO.Put (Item => "Enter a 3-letter day of the week > ");
  Day_IO.Get (Item => Today);

  -- find tomorrow
  IF Today = Days'Last THEN
    Tomorrow := Days'First;
  ELSE
    Tomorrow := Days'Succ(Today);
  END IF;

  Text_IO.Put (Item => "Tomorrow is ");
  Day_IO.Put (Item => Tomorrow);
  Text_IO.New_Line;

  -- Is Tomorrow a week day or a weekend day?
  IF Tomorrow IN Weekdays THEN
    Text_IO.Put (Item => "Another day, another dollar...");
    Text_IO.New_Line;
  ELSE
    Text_IO.Put (Item => "We've worked hard, let's play hard!");
    Text_IO.New_Line;
  END IF;

  Text_IO.Put (Item => "Have a good day tomorrow.");
  Text_IO.New_Line;

END WorkDays;
