WITH Text_IO;
PROCEDURE DisplayDays IS
 
  -- display the days of the week, weekdays, weekend days;
  -- demonstrate enumeration subtypes and how they can be used
  -- to control a loop

  TYPE Days IS (Mon, Tue, Wed, Thu, Fri, Sat, Sun);
  SUBTYPE WeekDays IS Days RANGE Mon .. Fri;
  SUBTYPE WeekEnd  IS Days RANGE Sat .. Sun;
  PACKAGE Day_IO IS 
     NEW Text_IO.Enumeration_IO (Enum => Days);
 
BEGIN -- DisplayDays

  Text_IO.Put (Item => "The days of the week are ");
  FOR Day IN Days LOOP
    Day_IO.Put (Item => Day, Width => 4);
  END LOOP;
  Text_IO.New_Line;

  Text_IO.Put (Item => "The weekdays are ");
  FOR Day IN WeekDays LOOP
    Day_IO.Put (Item => Day, Width => 4);
  END LOOP;
  Text_IO.New_Line;

  Text_IO.Put (Item => "The weekend days are ");
  FOR Day IN WeekEnd LOOP
    Day_IO.Put (Item => Day, Width => 4);
  END LOOP;
  Text_IO.New_Line;

END DisplayDays;
