WITH Text_IO;
PROCEDURE ReverseDisplayDays IS
 
  -- display the days of the week, weekdays, weekend days;
  -- demonstrate enumeration subtypes and how they can be used
  -- to control a loop running in reverse

  TYPE Days IS (Mon, Tue, Wed, Thu, Fri, Sat, Sun);
  SUBTYPE WeekDays IS Days RANGE Mon .. Fri;
  SUBTYPE WeekEnd  IS Days RANGE Sat .. Sun;
  PACKAGE Day_IO IS 
     NEW Text_IO.Enumeration_IO (Enum => Days);
 
BEGIN -- ReverseDisplayDays

  Text_IO.Put (Item => "The days of the week are ");
  FOR Day IN REVERSE Days LOOP
    Day_IO.Put (Item => Day, Width => 4);
  END LOOP;
  Text_IO.New_Line;

  Text_IO.Put (Item => "The weekdays are ");
  FOR Day IN REVERSE WeekDays LOOP
    Day_IO.Put (Item => Day, Width => 4);
  END LOOP;
  Text_IO.New_Line;

  Text_IO.Put (Item => "The weekend days are ");
  FOR Day IN REVERSE WeekEnd LOOP
    Day_IO.Put (Item => Day, Width => 4);
  END LOOP;
  Text_IO.New_Line;

END ReverseDisplayDays;
