WITH Text_IO;
WITH My_Int_IO;
WITH UsefulFunctions;
PROCEDURE RobustSumFact IS
 
  -- Prompts the user for an integer N from 1 to 10 
  -- and displays the sum and factorial of all integers from
  -- 1 to N. Sum and Factorial are gotten from package UsefulFunctions.

  SUBTYPE OneToTen IS Positive RANGE 1..10;

  MaxNum:       OneToTen;   -- input - a value from one to ten
  SumToCount:   Positive;   -- output - sum of integers from one to Count
  ProdToCount:  Positive;   -- output - product of integers from one to Count
 
BEGIN -- RobustSumFact   

  Text_IO.Put (Item => "Please enter an integer from 1 to 10 > ");
  My_Int_IO.Get (Item => MaxNum);
  Text_IO.New_Line;

  Text_IO.Put(Item => "  N    Sum    Factorial");
  Text_IO.New_Line;
  Text_IO.Put(Item => "  ----------------------");
  Text_IO.New_Line;

  FOR Count IN 1..MaxNum LOOP
    SumToCount   := UsefulFunctions.Sum (N => Count);
    ProdToCount  := UsefulFunctions.Factorial (N => Count);

    My_Int_IO.Put (Item => Count, Width => 3);
    My_Int_IO.Put (Item => SumToCount, Width => 7);
    My_Int_IO.Put (Item => ProdToCount, Width => 9);
    Text_IO.New_Line;
  END LOOP;

EXCEPTION

  WHEN Constraint_Error =>
    Text_IO.Put (Item => "The input value is out of range.");
    Text_IO.New_Line;
  WHEN Text_IO.Data_Error =>
    Text_IO.Put (Item => "The input value is not well formed.");
    Text_IO.New_Line;
  WHEN Numeric_Error =>
    Text_IO.Put (Item => "The result is too large to compute.");
    Text_IO.New_Line;

END RobustSumFact;
