WITH Text_IO;
WITH My_Int_IO;
WITH MinMax;
PROCEDURE MinMaxAverage IS

-- Finds and displays the minimum, maximum, and average
-- of a list of data items.   

  NumValues:    Positive;     -- the number of items to be averaged
  Sum:          Integer;      -- the sum being accumulated   
  CurrentValue: Integer;      -- the next data item to be added   

  Smallest:     Integer;      -- minimum of the data values
  Largest:      Integer;      -- maximum of the data values
  Average:      Integer;      -- average of the data values

BEGIN  -- MinMaxAverage

  -- Read the number of items to be averaged 
  Text_IO.Put(Item => 
    "Enter number (at least 1) of integer items to be averaged > ");
  My_Int_IO.Get(Item => NumValues);  
  Text_IO.New_Line;

  -- Initialize program variables
  Smallest := Integer'Last;
  Largest := Integer'First;
  Sum := 0;

  -- Read each data item, add it to Sum, 
  -- and check if it is a new minimum or maximum
  FOR Count IN 1 .. NumValues LOOP
    Text_IO.Put(Item => "Integer item no. ");
    My_Int_IO.Put(Item => Count, Width => 1);
    Text_IO.Put(Item => " > ");
    My_Int_IO.Get(Item => CurrentValue);  

    Sum := Sum + CurrentValue;
    Smallest := Minmax.Minimum(Value1 => Smallest, Value2 => CurrentValue);
    Largest  := Minmax.Maximum(Value1 => Largest,  Value2 => CurrentValue);
  END LOOP;

  -- compute the average; since Sum and NumValues are integers,
  -- the average will be rounded to the nearest integer

  Average := Sum / NumValues;

  -- Display the results
  Text_IO.Put(Item => "The Smallest is ");
  My_Int_IO.Put(Item => Smallest, Width => 1);  
  Text_IO.New_Line;
  Text_IO.Put(Item => "The Largest is ");
  My_Int_IO.Put(Item => Largest, Width => 1);  
  Text_IO.New_Line;
  Text_IO.Put(Item => "The Average is ");
  My_Int_IO.Put(Item => Average, Width => 1);  
  Text_IO.New_Line;

END MinMaxAverage;
