WITH Text_IO;
WITH My_Int_IO;
WITH MinMax;
PROCEDURE MinMaxAvgFile IS

-- Finds and displays the minimum, maximum, and average
-- of a list of data items.   

  NumValues:    Positive;          -- the number of items to be averaged
  Sum:          Integer;           -- the sum being accumulated   
  CurrentValue: Integer;           -- the next data item to be added   
  Smallest:     Integer;           -- minimum of the data values
  Largest:      Integer;           -- maximum of the data values
  Average:      Integer;           -- average of the data values
  TestScores:   Text_IO.File_Type; -- program variable naming the input file

BEGIN  -- SumItems   

  -- Open the file and associate it with the file variable name
  Text_IO.Open
    (File => TestScores, Mode => Text_IO.In_File, Name => "SCORES.DAT");

  -- Read from the file the number of items to be averaged 
  My_Int_IO.Get(File => TestScores, Item => NumValues);  
  Text_IO.Put("The number of scores to be averaged is ");
  My_Int_IO.Put(Item => NumValues, Width => 1);  
  Text_IO.New_Line;

  -- Initialize program variables
  Smallest := Integer'Last;
  Largest := Integer'First;
  Sum := 0;

  -- Read each data item, log to the screen, add it to Sum, 
  -- and check if it is a new minimum or maximum
  FOR Count IN 1 .. NumValues LOOP
    My_Int_IO.Get(File => TestScores, Item => CurrentValue);  
    Text_IO.Put("Score number ");
    My_Int_IO.Put(Item => Count, Width => 1);  
    Text_IO.Put(" is ");
    My_Int_IO.Put(Item => CurrentValue, Width => 1);  
    Text_IO.New_Line;

    Sum := Sum + CurrentValue;
    Smallest := Minmax.Minimum(Value1 => Smallest, Value2 => CurrentValue);
    Largest  := Minmax.Maximum(Value1 => Largest,  Value2 => CurrentValue);
  END LOOP;

  -- compute the average; since Sum and NumValues are integers,
  -- the average will be rounded to the nearest integer
  Average := Sum / NumValues;

  -- display the results
  Text_IO.Put(Item => "The Smallest is ");
  My_Int_IO.Put(Item => Smallest, Width => 1);  
  Text_IO.New_Line;
  Text_IO.Put(Item => "The Largest is ");
  My_Int_IO.Put(Item => Largest, Width => 1);  
  Text_IO.New_Line;
  Text_IO.Put(Item => "The Average is ");
  My_Int_IO.Put(Item => Average, Width => 1);  
  Text_IO.New_Line;

END MinMaxAvgFile;
