WITH Text_IO;
WITH My_Flt_IO;
PROCEDURE WormAndApple IS
 
-- Displays distances between a worm and an apple.  The worm keeps reducing
-- the distance by its body length until it is close enough to bite the apple.

  SUBTYPE NonNegFloat IS Float RANGE 0.0 .. Float'Last;
  
  WormLength: CONSTANT NonNegFloat := 3.5;  -- worm body length in inches
 
  InitialDist: NonNegFloat;  -- starting distance of worm from apple  
  Distance:    NonNegFloat;  -- distance between worm and apple   
 
BEGIN -- WormAndApple   

  Text_IO.Put(Item => "Initial distance (float) between worm and apple > ");
  My_Flt_IO.Get(Item => InitialDist);  
  Text_IO.New_Line; 
 
  -- Cut the distance between the worm and the apple by the worm's
  -- body length until the worm is close enough to bite the apple 
  Distance := InitialDist;

  WHILE Distance > WormLength LOOP
    Text_IO.Put(Item => "The distance is ");
    My_Flt_IO.Put(Item => Distance, Fore => 4, Aft => 2, Exp => 0);
    Text_IO.New_Line;

    Distance := Distance - WormLength;   -- reduce Distance 
  END LOOP;
 
  -- Display final distance before entering the apple.   
  Text_IO.New_Line;
  Text_IO.Put(Item => "Final distance between worm and apple is ");
  My_Flt_IO.Put(Item => Distance, Fore => 4, Aft => 2, Exp => 0);
  Text_IO.New_Line;
  Text_IO.Put(Item => "The worm bites the apple.");
  Text_IO.New_Line;

END WormAndApple;
