WITH Text_IO;
WITH My_Flt_IO;
PROCEDURE FreeFall IS
 
-- Displays the height of an object dropped
-- from a tower until it its the ground.

  SUBTYPE NonNegFloat IS Float RANGE 0.0 .. Float'Last;
  
  g : CONSTANT NonNegFloat := 9.80665;      -- gravitational constant
 
  Height: Float;         -- height of object   
  Tower:  NonNegFloat;   -- height of tower   
  t:      NonNegFloat;   -- elapsed time   
  DeltaT: NonNegFloat;   -- time interval   
 
BEGIN -- FreeFall

  -- Enter tower height and time interval.   
  Text_IO.Put(Item => "Please enter all values in floating-point form.");
  Text_IO.New_Line;
  Text_IO.Put(Item => "Tower height in meters > ");
  My_Flt_IO.Get(Item => Tower);   
  Text_IO.Put(Item => "Time in seconds between table lines > ");
  My_Flt_IO.Get(Item => DeltaT);  
  Text_IO.New_Line(2);
 
  -- Display object height until it hits the ground.   
  Text_IO.Put(Item => "        Time      Height");  
  Text_IO.New_Line;

  t := 0.0;
  Height := Tower;

  WHILE Height > 0.0 LOOP
    My_Flt_IO.Put(Item => t, Fore => 8, Aft => 3, Exp => 0);
    My_Flt_IO.Put(Item => Height, Fore => 8, Aft => 3, Exp => 0);  
    Text_IO.New_Line;
    t := t + DeltaT;
    Height := Tower - 0.5 * g * (t ** 2);
  END LOOP;
 
  -- Object hits the ground.   
  Text_IO.New_Line;  
  Text_IO.Put(Item => "SPLATT!!!");  
  Text_IO.New_Line;

END FreeFall;
