WITH Text_IO;
WITH My_Int_IO;
PROCEDURE Multiply IS
  
-- Finds the product of a collection of non-zero integers.  If there
-- are multiple consecutive occurrences of the same value, only the
-- the first value is included in the product.
  
  Sentinel : CONSTANT Natural := 0;  -- sentinel value   

  NextNum :     Integer;        -- input - new data item   
  PreviousNum : Integer;        -- last data item   
  Product :     Integer;        -- output - product of data   

BEGIN -- Multiply   

  -- Compute product of non-zero, non-repeating data items.   
  Product := 1;
  PreviousNum := Sentinel;
  Text_IO.Put (Item => "Enter 0 to stop.");  
  Text_IO.New_Line;
  Text_IO.Put (Item => "Enter first number > ");
  My_Int_IO.Get (Item => NextNum);          -- priming read

  WHILE NextNum /= Sentinel LOOP
    -- invariant:
    --   No prior value of NextNum is the sentinel and
    --   Product in pass i is Product in pass i-1 if NextNum is
    --   PreviousNum; otherwise, Product in pass i is NextNum * Product
    --   in pass i-1 (for i > 1)

    IF NextNum /= PreviousNum THEN
      Product := Product * NextNum ;        -- compute next product   
    END IF;
    PreviousNum := NextNum;                 -- remember previous item   
    Text_IO.Put (Item => "Enter next  number  > ");
    My_Int_IO.Get (Item => NextNum);        -- read next item   
  END LOOP;
  -- assert: NextNum is the sentinel and Product is the product of
  --   every value of NextNum such that NextNum /= PreviousNum
    
  Text_IO.Put (Item => "The product is ");  -- display result   
  My_Int_IO.Put(Item => Product, Width => 1);
  Text_IO.New_Line;

END Multiply;
