WITH Text_IO;
WITH My_Int_IO;
PROCEDURE ExceptionLoop IS

  MinVal : CONSTANT Integer := -10;
  MaxVal : CONSTANT Integer :=  10;
  SUBTYPE SmallInt  IS Integer RANGE MinVal .. MaxVal;

  InputValue: SmallInt;
  Sum:        Integer;
            
BEGIN -- ExceptionLoop

  Sum := 0;

  FOR Count IN 1..5 LOOP -- counts the five values we need to read

    LOOP      -- inner loop just to control robust input
      BEGIN   -- block for exception handler

        Text_IO.Put(Item => "Enter an integer between ");
        My_Int_IO.Put(Item => SmallInt'First, Width => 0);  
        Text_IO.Put(Item => " and ");
        My_Int_IO.Put(Item => SmallInt'Last, Width => 0);  
        Text_IO.Put(Item => " > ");
        My_Int_IO.Get(Item => InputValue);

        EXIT; -- leave the loop only upon correct input

      EXCEPTION
        WHEN Constraint_Error =>
          Text_IO.Put ("Value entered is out of range. Please try again.");
          Text_IO.New_Line;
        WHEN Text_IO.Data_Error =>
          Text_IO.Put ("Value entered not an integer. Please try again.");
          Text_IO.New_Line;
          Text_IO.Skip_Line;

      END;    -- block for exception handler
    END LOOP;
    -- assert: InputValue is in the range MinN to MaxN   

    Sum := Sum + InputValue; -- add new value into Sum
  END LOOP;

  Text_IO.Put (Item => "The sum is ");
  My_Int_IO. Put (Item => Sum, Width => 1);
  Text_IO.New_Line;

END ExceptionLoop;
