WITH Text_IO;
WITH My_Int_IO;
WITH Screen;
PROCEDURE MenuHandler IS

  SUBTYPE MenuValues IS Positive RANGE 1..6;
  MenuSelection : MenuValues;

BEGIN -- MenuHandler

  LOOP
    BEGIN -- exception handler block

      Screen.ClearScreen;
      Screen.MoveCursor (Row => 5, Column => 20);
      Text_IO.Put (Item => "Select one of the operations below.");
      Screen.MoveCursor (Row => 7, Column => 20);
      Text_IO.Put (Item => "1. Compute an Average");
      Screen.MoveCursor (Row => 8, Column => 20);
      Text_IO.Put (Item => "2. Compute a Standard Deviation");
      Screen.MoveCursor (Row => 9, Column => 20);
      Text_IO.Put (Item => "3. Find the Median");    
      Screen.MoveCursor (Row => 10, Column => 20);
      Text_IO.Put (Item => "4. Find the smallest and largest values");
      Screen.MoveCursor (Row => 11, Column => 20);
      Text_IO.Put (Item => "5. Plot the data");     
      Screen.MoveCursor (Row => 12, Column => 20);
      Text_IO.Put (Item => "6. Exit the program");   

      Screen.MoveCursor (Row => 14, Column => 20);
      Text_IO.Put ("Enter a number between 1 and 6 > ");

      -- this statement could raise an exception if input is out of range
      -- or not an integer value
      My_Int_IO.Get (Item => MenuSelection);

      -- these statements will be executed only if the input is correct
      -- otherwise, control passes to exception handler
      Screen.MoveCursor (Row => 17, Column => 20);
      Text_IO.Put ("Thank you for correct input.");      
      EXIT;      -- valid data

    EXCEPTION    -- invalid data
      
      WHEN Text_IO.Data_Error =>
        Screen.MoveCursor (Row => 17, Column => 20);
        Text_IO.Put (Item => "Value entered is not an integer.");
        Text_IO.Skip_Line;
        DELAY 1.0;
      WHEN Constraint_Error =>  
        Screen.MoveCursor (Row => 17, Column => 20);
        Text_IO.Put (Item => "Value entered is out of range.");   
        DELAY 1.0;

    END;         -- of exception handler block
  END LOOP;

  Screen.MoveCursor (Row =>23, Column => 20);
  Text_IO.Put (Item => "Correct input entered; do the requested task here");
  Screen.MoveCursor (Row => 24, Column => 1);

END MenuHandler;
