WITH Text_IO;
WITH My_Flt_IO;
PROCEDURE Sort3Numbers IS

-- Reads three numbers and sorts them
-- so that they are in increasing order.

  Num1 : Float;            -- a list of three cells   
  Num2 : Float;            
  Num3 : Float;            

  -- procedure specification
  PROCEDURE Order (X: IN OUT Float; Y: IN OUT Float);

  -- procedure body
  PROCEDURE Order (X: IN OUT Float; Y: IN OUT Float) IS
   
  -- Orders a pair of numbers represented by X and Y so that the
  -- smaller number is in X and the larger number is in Y.
  -- Pre:  X and Y are assigned values.
  -- Post: X has the smaller value and Y has the larger value.

    Temp : Float;          -- copy of number originally in X   

  BEGIN  -- Order   

    IF X > Y THEN
      -- interchange the values of X and Y   
      Temp := X;            -- Store old X in Temp   
      X := Y;               -- Store old Y in X   
      Y := Temp;            -- Store old X in Y   
    END IF;

  END Order;


BEGIN  -- Sort3Numbers   

  Text_IO.Put(Item => "Enter 3 float numbers to be sorted, one per line.");
  Text_IO.New_Line;
  My_Flt_IO.Get(Item => Num1);  
  My_Flt_IO.Get(Item => Num2); 
  My_Flt_IO.Get(Item => Num3);  

  -- Sort the numbers   
  Order (X => Num1, Y => Num2);      -- Order the data in Num1 and Num2   
  Order (X => Num1, Y => Num3);      -- Order the data in Num1 and Num3
  Order (X => Num2, Y => Num3);      -- Order the data in Num2 and Num3   

  -- Display the results.   
  Text_IO.Put(Item => "The three numbers in order are: ");
  My_Flt_IO.Put(Item => Num1, Fore => 5, Aft => 2, Exp => 0);  
  My_Flt_IO.Put(Item => Num2, Fore => 5, Aft => 2, Exp => 0);  
  My_Flt_IO.Put(Item => Num3, Fore => 5, Aft => 2, Exp => 0);  
  Text_IO.New_Line;

END Sort3Numbers;

