WITH Text_IO;
WITH RobustInput;
WITH My_Int_IO;
PROCEDURE DisplayDigits IS
  
-- Displays the digits of Decimal in reverse order.
-- Pre:  Decimal is assigned a value.
-- Post: Each digit of Decimal is displayed, starting with the
--       least significant one.
  
  SUBTYPE Natural_32767 IS Natural RANGE 0..32_767;

  Base : CONSTANT Natural := 10;      -- number system base   
  Decimal : Natural_32767;            -- original number
  Digit :   Natural;                  -- each digit   

BEGIN  -- DisplayDigits   

  RobustInput.Get(Item=>Decimal, MinVal=>0, MaxVal => Natural_32767'Last);

  -- Find and display remainders of Decimal divided by 10   
  Text_IO.Put(Item=> "The digits in reverse order are ");
  WHILE Decimal /= 0 LOOP
    -- invariant:
    -- Decimal in pass i is (Decimal in pass i-1) / Base (for i > 1)
    -- and Digit in pass i is (Decimal in pass i-1) REM Base (for i > 1)
    -- and Decimal >= 0

    Digit := Decimal REM Base;     -- Get next remainder   
    My_Int_IO.Put(Item => Digit, Width => 1);
    Decimal := Decimal / Base;     -- Get next quotient   

  END LOOP;
  -- assert: Decimal is zero   

  Text_IO.New_Line;

END DisplayDigits;
