WITH Text_IO;
WITH My_Int_IO;
WITH Calendar;
PROCEDURE TimeOfDay IS

-- displays the current time of day in hh:mm:ss form, 
-- using the 24-hour clock. Current time is gotten from Calendar.Clock
  
  CurrentTime :      Calendar.Time;
  SecsPastMidnight : Calendar.Day_Duration;
  MinsPastMidnight : Natural;
  Secs :             Natural;
  Mins :             Natural;
  Hrs :              Natural;

BEGIN -- TimeOfDay

  CurrentTime := Calendar.Clock;
  SecsPastMidnight := Calendar.Seconds(CurrentTime);
  MinsPastMidnight := Natural(Float(SecsPastMidnight)/60.0 - 0.5);

  Secs :=  
    Natural(Float(SecsPastMidnight) - (60.0 * Float(MinsPastMidnight)));
  Mins :=             MinsPastMidnight REM 60;
  Hrs  :=             MinsPastMidnight / 60;

  Text_IO.Put("The current time is ");
  My_Int_IO.Put (Item => Hrs, Width => 1);
  Text_IO.Put (Item => ':');

  IF Mins < 10 THEN
     Text_IO.Put (Item => '0');
  END IF;
  My_Int_IO.Put (Item => Mins, Width => 1);
  Text_IO.Put (Item => ':');

  IF Secs < 10 THEN
     Text_IO.Put (Item => '0');
  END IF;
  My_Int_IO.Put (Item => Secs, Width => 1);
  Text_IO.New_Line;

END TimeOfDay;
