WITH Text_IO;
WITH My_Flt_IO;
WITH Math; USE Math;
PROCEDURE SineCurve IS

-- Plots a sine curve.   

  Pi :           CONSTANT Float   := 3.14159;     -- constant Pi   
  RadPerDegree : CONSTANT Float   := Pi / 180.0;  -- radians per degree   
  MinAngle :     CONSTANT Float   := 0.0;         -- smallest angle   
  MaxAngle :     CONSTANT Float   := 360.0;       -- largest angle   
  PlotWidth :    CONSTANT Integer := 40;          -- width of plot   
  PlotHeight :   CONSTANT Integer := 20;          -- height of plot   
  StepAngle :    CONSTANT Float := (MaxAngle-MinAngle) / Float(PlotHeight);  
                                                  -- change in angle   
  Star :         CONSTANT Character := '*';       -- symbol being plotted   
  Blank :        CONSTANT Character := ' ';       -- blank symbol   

  SUBTYPE ColumnRange IS Integer RANGE 0..PlotWidth;

  Angle  :       Float;                           -- angle in degrees   
  Radian :       Float;                           -- angle in radians   
  Scale :        Float;                           -- scale factor   
  Pad :          ColumnRange;                     -- size of blank padding   

BEGIN  -- SineCurve   

  Text_IO.Put(Item => "                   Sine curve plot");
  Text_IO.New_Line(2);
  Scale := Float(PlotWidth / 2);
  Angle := MinAngle;

  WHILE Angle <= MaxAngle LOOP

    Radian := Angle * RadPerDegree;
    Pad := Natural(Scale * (1.0 + Sin(Radian)));

    My_Flt_IO.Put(Item =>Angle, Fore => 4, Aft => 0, Exp => 0);  

    -- Display blank padding   
    Text_IO.Put(Item => Blank);
    FOR BlankCount IN 1 .. Pad LOOP
      Text_IO.Put(Item => Blank);
    END LOOP;       

    Text_IO.Put(Item => Star);            -- Plot * in next column   
    Text_IO.Put(Item => "        ");
    My_Flt_IO.Put(Item =>Sin(Radian), Fore => 1, Aft => 6, Exp => 0);  
    Text_IO.New_Line;
    Angle := Angle + StepAngle;

  END LOOP;

END SineCurve;

