PROCEDURE Get (Item : OUT Integer; MinVal : Integer; MaxVal : Integer) IS
  
-- Reads an integer between MinVal and MaxVal into Item
-- Pre:  MinVal and MaxVal are assigned values.
-- Post: A value between MinVal and MaxVal is read into Item.
  
  Between : Boolean;    -- program flag -- loop control   
  TempN :   Integer;    -- temporary copy to read into

BEGIN -- Get 

  -- Keep reading until a valid number is read.   
  Between := False;   -- Assume a valid number is not read   
  WHILE NOT Between LOOP
    -- invariant:
    --   All prior values of TempN are outside the range MinVal to MaxVal
      
    Text_IO.Put(Item => "Enter an integer between ");
    My_Int_IO.Put(Item => MinVal, Width => 0);  
    Text_IO.Put(Item => " and ");
    My_Int_IO.Put(Item => MaxVal, Width => 0);  
    Text_IO.Put(Item => " > ");
    My_Int_IO.Get(Item => TempN);
    Between := (TempN >= MinVal) AND (TempN <= MaxVal);

  END LOOP;
  -- assert: TempN is in the range MinVal to MaxVal   

  Item := TempN;

END Get;
