WITH Text_IO;
WITH My_Int_IO;
PROCEDURE BlankCount IS

-- Counts the number of blanks in a sentence.   

   Blank :    CONSTANT Character :=  ' ';  -- character being counted   
   Sentinel : CONSTANT Character :=  '.';   -- sentinel character   

   Next  : Character;             -- next character in sentence   
   Count : Natural;               -- number of blank characters   

BEGIN  -- BlankCount   

  Count :=  0;                    -- Initialize Count   
  Text_IO.Put(Item => "Enter a sentence ending with a period.");
  Text_IO.New_Line;

  -- Process each input character up to the period   
  Text_IO.Get(Item => Next);      -- Get first character   
  Text_IO.Put(Item => Next);
  WHILE Next /= Sentinel LOOP
    -- invariant: Count is the count of blanks so far and
    --   no prior value of Next is the sentinel
      
    IF Next = Blank THEN
      Count := Count + 1;         -- Increment blank count   
    END IF;
    Text_IO.Get(Item => Next);    -- Get next character   
    Text_IO.Put(Item => Next);
  END LOOP;
  -- assert: Count is the count of blanks and Next is the sentinel   

  Text_IO.New_Line;
  Text_IO.Put(Item => "The number of blanks is ");
  My_Int_IO.Put(Item => Count, Width => 1);
  Text_IO.New_Line;

END BlankCount;

