WITH Text_IO;
WITH My_Int_IO;
WITH My_Flt_IO;
PROCEDURE ShowDiff IS
  
-- Computes the average value of an array of data and
-- prints the difference between each value and the average.
  
  MaxItems : CONSTANT Positive := 8;    -- number of data items   

  SUBTYPE Index IS Positive RANGE 1..MaxItems; 
  TYPE FloatArray IS ARRAY (Index) OF Float;

  X        : FloatArray;             -- array of data   
  Average  : Float;                  -- average value of data   
  Sum      : Float;                  -- sum of the data   

BEGIN -- ShowDiff   

  -- Enter the data.   
  Text_IO.Put(Item => "Please enter ");
  My_Int_IO.Put(Item => MaxItems, Width=>0);
  Text_IO.Put(Item => " floating-point numbers > ");
  Text_IO.New_Line;

  FOR I IN Index LOOP
    My_Flt_IO.Get(Item => X(I));
  END LOOP;
  Text_IO.New_Line;

  -- Compute the average value.   
  Sum := 0.0;                        -- Initialize SUM   
  FOR I IN Index LOOP
    Sum := Sum + X(I);               -- Add each element to Sum   
  END LOOP;

  Average := Sum / FLOAT(MaxItems);  -- Find average value   
  Text_IO.Put(Item => "Average value is ");
  My_Flt_IO.Put(Item=>Average, Fore=>5, Aft=>2, Exp=>0);  
  Text_IO.New_Line;

  -- Display the difference between each item and the average.   
  Text_IO.Put(Item => "Table of differences between X(I) and average");
  Text_IO.New_Line;
  Text_IO.Put(Item => "   I        X(I)     Difference");  
  Text_IO.New_Line;

  FOR I IN Index LOOP
    My_Int_IO.Put(Item => I, Width=>4);  
    Text_IO.Put(Item => "    ");
    My_Flt_IO.Put(Item=>X(I), Fore=>5, Aft=>2, Exp=>0);  
    Text_IO.Put(Item => "    ");
    My_Flt_IO.Put(Item=>X(I)-Average, Fore=>5, Aft=>2, Exp=>0);  
    Text_IO.New_Line;
  END LOOP;

END ShowDiff;
