WITH Text_IO;
WITH My_Int_IO;
PROCEDURE Concordance IS

 -- Finds and displays the number of occurrences of each letter.
 -- The case of each letter is immaterial.  Letters with counts
 -- of zero are not displayed.
   
   Sentinel : CONSTANT Character := '.';

   SUBTYPE UpperCase IS Character RANGE 'A'..'Z';
   SUBTYPE LowerCase IS Character RANGE 'a'..'z';
   TYPE LetterCountArray IS ARRAY (UpperCase) OF Natural;
   TYPE LetterFoundArray IS ARRAY (UpperCase) OF Boolean;

   LetterCount : LetterCountArray; -- array of counts   
   LetterFound : LetterFoundArray; -- array of counts   
   NextChar : Character;                   -- each input character   

BEGIN -- Concordance   

  -- Initialize LetterCount and LetterFound.   
  LetterCount := (OTHERS => 0);             -- Initialize counts   
  LetterFound := (OTHERS => False);         -- Initialize flags   

  -- Read and process each data character.   
  Text_IO.Put(Item => "Enter a line of text ending with a period.");
  Text_IO.New_Line;

  LOOP
    Text_IO.Get(Item => NextChar);

    -- Increment the count for each letter character.   
    IF NextChar IN UpperCase THEN
      LetterCount(NextChar) := LetterCount(NextChar) + 1;
      LetterFound(NextChar) := TRUE;        -- Set letter flag   
    ELSIF NextChar IN LowerCase THEN
      NextChar := Character'Val(Character'Pos(NextChar)
                   - Character'Pos('a') + Character'Pos('A'));
      LetterCount(NextChar) := LetterCount(NextChar) + 1;
      LetterFound(NextChar) := TRUE;        -- Set letter flag   
    END IF;
    EXIT WHEN NextChar = Sentinel;
  END LOOP;


  -- Display counts of letters that are in the line.   
  Text_IO.New_Line;
  Text_IO.New_Line;
  Text_IO.Put(Item => "Letter     Occurrences");
  Text_IO.New_Line;
  FOR WhichChar IN UpperCase LOOP
    IF LetterFound(WhichChar) THEN
      Text_IO.Put(Item => "     ");
      Text_IO.Put(Item => WhichChar);
      My_Int_IO.Put(Item => LetterCount(WhichChar), Width => 16);
      Text_IO.New_Line;
    END IF;
  END LOOP;

END Concordance;
