WITH Text_IO;
WITH My_Int_IO;
PROCEDURE SortScores IS

-- Test program for procedure SelectSort
-- Sorts and displays an array of test scores
-- The array is initialized with eleven non-zero scores.

  MaxSize : CONSTANT Positive := 250;
  MaxScore : CONSTANT Positive := 100;

  SUBTYPE ClassIndex IS Positive RANGE 1..MaxSize;
  SUBTYPE ClassRange IS Natural  RANGE 0..MaxSize;
  SUBTYPE ScoreRange IS Natural  RANGE 0..MaxScore;

  TYPE ScoreArray IS ARRAY (ClassIndex) OF ScoreRange; 

  Scores : ScoreArray;
  ClassSize : ClassRange;


  PROCEDURE Exchange(Score1, Score2: IN OUT ScoreRange) IS

  -- exchanges two values of type ScoreRange
  -- Pre: Score1 and Score2 are defined
  -- Post: the values of Score1 and Score2 are interchanged

    TempScore: ScoreRange; 

  BEGIN

    TempScore := Score1;
    Score1    := Score2;
    Score2    := TempScore;

  END Exchange;


  PROCEDURE SelectSort(Scores: IN OUT ScoreArray; ClassSize: IN ClassRange) IS

    IndexOfMax: ClassRange;

  BEGIN

    FOR PositionToFill IN REVERSE 2..ClassSize LOOP

      -- Find the element in subarray 1..PositionToFill
      -- with largest Score
      IndexOfMax := PositionToFill;
      FOR ItemToCompare IN REVERSE 1..PositionToFill - 1 LOOP
        IF Scores(ItemToCompare) > Scores(IndexOfMax) THEN
          IndexOfMax := ItemToCompare;
        END IF;
      END LOOP;
      -- assert: element at IndexOfMax is largest in subarray

      IF IndexOfMax /= PositionToFill THEN
        Exchange(Scores(PositionToFill),Scores(IndexOfMax));
      END IF;

    END LOOP;

  END SelectSort;


  PROCEDURE DisplayScores(Scores: ScoreArray; ClassSize: ClassRange) IS

  BEGIN

    FOR I IN 1..ClassSize LOOP
      My_Int_IO.Put(Item => I, Width => 3);
      Text_IO.Put(Item => "  ");
      My_Int_IO.Put(Item => Scores(I), Width => 4);
      Text_IO.New_Line;
    END LOOP;

  END DisplayScores;
  

BEGIN -- SortScores

  ClassSize := 11;
  Scores := (75, 25, 100, 62, 79, 80, 85, 75, 91, 67, 68, OTHERS => 0);

  Text_IO.Put(Item => "Original Test Array:");
  Text_IO.New_Line;
  Text_IO.New_Line;
  DisplayScores(Scores => Scores, ClassSize => ClassSize);
  Text_IO.New_Line;

  SelectSort(Scores => Scores, ClassSize => ClassSize);
  Text_IO.New_Line;
  Text_IO.Put(Item => "Sorted Test Array:");
  Text_IO.New_Line;
  Text_IO.New_Line;
  DisplayScores(Scores => Scores, ClassSize => ClassSize);
  Text_IO.New_Line;

END SortScores;
