PROCEDURE ChangeTime (ElapsedTime : Natural;
                      TimeOfDay : IN OUT TimeRecord) IS

-- Updates the time of day, TimeOfDay, assuming a 24-hour clock and
-- an elapsed time of ElapsedTime in seconds.
-- Pre : ElapsedTime and record TimeOfDay are assigned values.
-- Post: TimeOfDay is "incremented" by ElapsedTime.
  
  NewHour : Natural;     -- temporary values   
  NewMin  : Natural; 
  NewSec  : Natural;

BEGIN -- ChangeTime   

  NewSec := TimeOfDay.Second + ElapsedTime;      -- total seconds   
  TimeOfDay.Second := NewSec REM 60;             -- seconds rem 60   
  NewMin := TimeOfDay.Minute + (NewSec / 60);    -- total minutes   
  TimeOfDay.Minute := NewMin REM 60;             -- minutes rem 60   
  NewHour := TimeOfDay.Hour + (NewMin / 60);     -- total hours   
  TimeOfDay.Hour := NewHour REM 24;              -- hours rem 24   
  
END ChangeTime;

