WITH Text_IO;
WITH My_Flt_IO;
WITH Math; USE Math;
PROCEDURE DistPoints IS

-- Finds the distance from a point to the origin.   

  TYPE Point IS RECORD
    X : Float;
    Y : Float;
  END RECORD;

  Point1 : Point;              -- one data point   
  Point2 : Point;              -- the other data point   


  PROCEDURE GetPoint(Item: OUT Point) IS

  -- reads the X and Y coordinates of a point
  -- Pre: none
  -- Post: the point, Item, is defined with values from the user

  BEGIN

    Text_IO.Put(Item => "Enter X coordinate (floating point) > ");  
    My_Flt_IO.Get(Item => Item.X);
    Text_IO.Put(Item => "Enter Y coordinate (floating point) > ");  
    My_Flt_IO.Get(Item => Item.Y);

  END GetPoint;


  FUNCTION Distance(P1 : Point; P2 : Point) RETURN Float IS

  -- calculates the Cartesian distance between two points
  -- Pre: P1 and P2 are defined
  -- Post: returns the distance

  BEGIN

    RETURN Sqrt((P2.X-P1.X) ** 2 + (P2.Y-P1.Y) ** 2);

  END Distance;

BEGIN -- DistPoints   

  Text_IO.Put(Item => "First Point");
  Text_IO.New_Line;
  GetPoint(Item => Point1);
  Text_IO.Put(Item => "Second Point");
  Text_IO.New_Line;
  GetPoint(Item => Point2);
  Text_IO.Put(Item => "Distance between points is ");
  My_Flt_IO.Put(Item => Distance(Point1, Point2), Fore=>1,Aft=>2,Exp=>0);
  Text_IO.New_Line;

END DistPoints;

