WITH Calendar;
WITH Text_IO;
WITH My_Int_IO;
PACKAGE BODY SimpleDates IS

-- body for package to represent calendar dates
-- in a form convenient for reading and displaying.

  PACKAGE Month_IO IS 
    NEW Text_IO.Enumeration_IO(Enum => Months);


  PROCEDURE Get(Item: OUT Date) IS
  -- gets a date in the form MMM DD YYYY
  -- Post: returns a date in Item

  BEGIN

    Month_IO.Get(Item => Item.Month);
    My_Int_IO.Get(Item => Item.Day);
    My_Int_IO.Get(Item => Item.Year);

  END Get;


  PROCEDURE Put(Item: IN Date) IS
  -- displays a date in mmm dd yyyy form
  -- Pre: Item is assigned a value
  -- Post: Displays a date in mmm dd yyyy form

  BEGIN

    Month_IO.Put (Item => Item.Month, Width=>1);
    Text_IO.Put(Item => ' ');
    My_Int_IO.Put(Item => Item.Day, Width => 1);
    Text_IO.Put(Item => ' '); 
    My_Int_IO.Put(Item => Item.Year, Width => 4);

  END Put;

  FUNCTION Today RETURN Date IS
 
  -- Finds today's date and returns it as a record of type Date
  -- Today's date is gotten from PACKAGE Calendar
 
    Right_Now  : Calendar.Time;           -- holds internal clock value
    Temp       : Date; 
   
  BEGIN -- Today
 
    -- Get the current time value from the computer's clock
    Right_Now := Calendar.Clock;
 
    -- Extract the current month, day, and year from the time value 
    Temp.Month := Months'Val(Calendar.Month(Right_Now)- 1); 
    Temp.Day := Calendar.Day  (Right_Now);
    Temp.Year := Calendar.Year (Date => Right_Now);
 
    RETURN Temp;

  END Today;

END SimpleDates;
