  -- procedure specifications for lower-level procedures

  PROCEDURE ReadStu (First : IN OUT Character;
                     Last  : IN OUT Character;
                     Score : OUT Natural);

  PROCEDURE Categorize (Score  : IN Natural;
                        MinSat : IN Natural;
                        MinOut : IN Natural;
                        NumUns : IN OUT Natural;
                        NumSat : IN OUT Natural;
                        NumOut : IN OUT Natural);

  PROCEDURE CheckHigh (Score : IN Natural; High : IN OUT Natural);


  PROCEDURE DoScores (MinSat : IN Natural;
                      MinOut : IN Natural;
                      NumUns : IN OUT Natural;
                      NumSat : IN OUT Natural;
                      NumOut : IN OUT Natural;
                      High   : IN OUT Natural) IS

  -- Reads each student"s initials and score, categorizes each score,
  -- and finds the high score.
  -- Pre:  MinSat and MinOut are assigned values.
  -- Post: NumUns, NumSat, and NumOut are the counts of scores in
  --       each category.  High is the highest score.
  -- Uses: ReadStu, Categorize, and CheckHigh

     Score : Natural;                       -- each exam score
     First : Character;                     -- student's initials
     Last  : Character;

  BEGIN -- DoScores
    -- Initialize category counters and  High
    NumUns := 0;
    NumSat := 0;
    NumOut := 0;
    High   := MinScore;

    -- Categorize each score and find High
    ReadStu (First, Last, Score);         -- Read first student's data
    WHILE First /= Sentinel LOOP
      -- Categorize Score and increment appropriate counter
      Categorize (Score, MinSat, MinOut, NumUns, NumSat, NumOut);
      CheckHigh (Score, High);         -- Check for high score
      ReadStu (First, Last, Score);    -- Read next student's data
    END LOOP;
  END DoScores; 
