WITH Text_IO;
PROCEDURE CopyFile IS

 -- program copies its input file TEST.DAT into its output file TEST.OUT
 -- then closes TEST.OUT, re-opens it for input,  
 -- and displays its contents on the screen.

  InData  : Text_IO.File_Type;
  OutData : Text_IO.File_Type;
  NextCh  : Character;

BEGIN -- CopyFile

  Text_IO.Open(File=>InData, Mode=>Text_IO.In_File, Name=>"TEST.DAT");
  Text_IO.Create(File=>OutData, Mode=>Text_IO.Out_File, Name=>"TEST.OUT");

  WHILE NOT Text_IO.End_of_File(File => InData) LOOP
    WHILE NOT Text_IO.End_of_Line(File => InData) LOOP

      Text_IO.Get(File => InData, Item => NextCh);
      Text_IO.Put(File => OutData, Item => NextCh);

    END LOOP;

    Text_IO.Skip_Line(File => InData);
    Text_IO.New_Line(File => OutData);
  END LOOP;

  Text_IO.Close(File => InData);
  Text_IO.Close(File => OutData);
  Text_IO.Open(File=>InData, Mode=>Text_IO.In_File, Name=>"TEST.OUT");

  WHILE NOT Text_IO.End_of_File(File => InData) LOOP
    WHILE NOT Text_IO.End_of_Line(File => InData) LOOP

      Text_IO.Get(File => InData, Item => NextCh);
      Text_IO.Put(Item => NextCh);

    END LOOP;

    Text_IO.Skip_Line(File => InData);
    Text_IO.New_Line;
  END LOOP;

  Text_IO.Close(File => InData);

EXCEPTION

  WHEN Text_IO.Name_Error =>
    Text_IO.Put(Item => "File TEST.DAT doesn't exist in this directory!");
    Text_IO.New_Line;

END CopyFile;
