WITH Text_IO;
WITH My_Int_IO;
WITH My_Flt_IO;
PROCEDURE SumItems IS

-- Finds and prints the sum of a list of data items.   

  NumItems : Natural;   -- the number of items to be added   
  Sum      : Float;     -- the sum being accumulated   

  PROCEDURE FindSum (N   : IN Natural; Sum : OUT Float) IS
  
  -- Finds the sum of a list of N data items.
  -- Pre:  N is assigned a value.
  -- Post: N data items are read and their sum is stored in Sum.
    
    Item  : Float;        -- the next data item to be added   

  BEGIN  -- FindSum   
    -- Read each data item and add it to Sum   
    Sum := 0.0;
    FOR Count IN 1..N  LOOP
      Text_IO.Put(Item => "Next number to be summed (float)> ");
      My_Flt_IO.Get(Item => Item);  
      Sum := Sum + Item;
    END LOOP;
  END FindSum;

BEGIN  -- SumItems   

  -- Read the number of items to be summed   
  Text_IO.Put(Item => "How many items will be summed? ");
  My_Int_IO.Get(Item => NumItems);  

  -- Find the sum of a list of data items   
  FindSum (N => NumItems, Sum => Sum);

  -- Print the sum   
  Text_IO.Put(Item => "The Sum is ");
  My_Flt_IO.Put(Item => Sum, Fore=>1, Aft=>2, Exp=>0);  
  Text_IO.New_Line;

END SumItems;

