WITH Text_IO;
PROCEDURE TestTriangle IS

  PROCEDURE Triangle (NumRows : IN Natural) IS

  -- Prints a triangle by displaying lines of increasing length.
  -- The number of lines is determined by NumRows.
  -- Pre:  NumRows is assigned a value.
  -- Post: A triangle is displayed.
  -- Requirements: Calls procedure PrintLine to display each line.
  

    PROCEDURE PrintLine (NumStars : IN Natural) IS
    
    --  Prints a row of asterisks.  The number of
    --  asterisks printed is determined by NumStars.
    --  Pre:  NumStars is assigned a value.
    --  Post: A row of asterisks is displayed.
      
       Star : CONSTANT Character := '*';  -- symbol being printed   

    BEGIN  -- PrintLine   

      -- Print a row of asterisks   
      FOR CountStar IN 1 .. NumStars LOOP
         Text_IO.Put(Item => Star);
      END LOOP;
      Text_IO.New_Line;

    END PrintLine;

  BEGIN  -- Triangle    

    -- Print lines of increasing length    
    FOR Row IN 1 .. NumRows LOOP
     PrintLine (NumStars => Row);
    END LOOP;

  END Triangle;

BEGIN -- TestTriangle

  Triangle(NumRows => 6);

END TestTriangle;
