WITH Text_IO;
WITH My_Int_IO;
PROCEDURE Grader IS

 -- Reads an exam scale and uses it to find the number of students who
 -- received outstanding, satisfactory, and unsatisfactory grades on an
 -- exam.  Also, finds the high score on the exam.
  
  MinSat : Natural;    -- in - boundaries for satisfatory category   
  MinOut : Natural;
  NumUns : Natural;    -- out - counters for each category   
  NumSat : Natural;
  NumOut : Natural;
  High   : Natural;    -- out - high score so far   

  Sentinel : CONSTANT Character := '*';  -- sentinel value   
  MinScore : CONSTANT Natural   := 0;    -- lowest possible score   

  PROCEDURE ReadScale (MinSat : OUT Natural; MinOut : OUT Natural) IS
  
  -- Reads the exam scale.
  -- Pre:  None
  -- Post: MinSat and MinOut are read in.
    
  BEGIN  -- ReadScale   

    -- Enter the exam scale   
    Text_IO.Put(Item => "Enter the minimum satisfactory score: ");
    My_Int_IO.Get(Item => MinSat);
    Text_IO.Put(Item => "Enter the minimum outstanding  score: ");
    My_Int_IO.Get(Item => MinOut);

  END ReadScale;


  PROCEDURE DoScores (MinSat : IN Natural; 
                      MinOut : IN Natural;
                      NumUns : IN OUT Natural;
                      NumSat : IN OUT Natural;
                      NumOut : IN OUT Natural;
                      High   : IN OUT Natural) IS
  
  -- Reads each student"s initials and score, categorizes each score,
  -- and finds the high score.
  -- Pre:  MinSat and MinOut are assigned values.
  -- Post: NumUns, NumSat, and NumOut are the counts of scores in
  --       each category.  High is the highest score.
  -- Uses: ReadStu, Categorize, and CheckHigh
    
     Score : Natural;                       -- each exam score   
     First : Character;                     -- student's initials
     Last  : Character;

  BEGIN -- DoScores stub
   
    Text_IO.Put(Item => "Procedure DoScores entered");
    Text_IO.New_Line;
    -- Initialize category counters and High   
    NumUns := 0;
    NumSat := 0;
    NumOut := 0;
    High   := 0;

  END DoScores;


  PROCEDURE Report (NumUns : IN Natural; NumSat : IN Natural;
                   NumOut : IN Natural; High   : IN Natural) IS
  
  -- Prints the final counts and the high score.
  -- Pre:  NumUns, NumSat, NumOut, and High are assigned values.
  -- Post: The program results are displayed.
   
  BEGIN  -- Report  

    Text_IO.New_Line;
    Text_IO.Put(Item => "Number of    outstanding scores: ");
    My_Int_IO.Put(Item => NumOut, Width => 3);  
    Text_IO.New_Line;
    Text_IO.Put(Item => "Number of   satisfactory scores: ");
    My_Int_IO.Put(Item => NumSat, Width => 3);  
    Text_IO.New_Line;
    Text_IO.Put(Item => "Number of unsatisfactory scores: ");
    My_Int_IO.Put(Item => NumUns, Width => 3);  
    Text_IO.New_Line;
    Text_IO.New_Line;
    Text_IO.Put(Item => "High score on exam: ");
    My_Int_IO.Put(Item => High, Width => 3);  
    Text_IO.New_Line;

  END Report;


BEGIN  -- Grader  

  -- Enter the exam scale  
  ReadScale (MinSat, MinOut);

  -- Read and categorize all scores and find the high score  
  DoScores (MinSat, MinOut, NumUns, NumSat, NumOut, High);

  -- Print count of scores in each category and the high score  
  Report (NumUns, NumSat, NumOut, High);

END Grader;
